module FortyTwo
  class Configuration
    AUTH_KEYS = [:api_key, :api_secret]

    attr_accessor *AUTH_KEYS

    def initialize(config_hash = nil)
      if config_hash.is_a?(Hash)
        config_hash.each do |config_name, config_value|
          self.send("#{config_name}=", config_value)
        end
      end
    end

    def invalid?
      AUTH_KEYS.any? { |key| send(key).nil? || send(key).empty? }
    end
  end
end
