require 'fortytwo/responses/user'

module FortyTwo
  module Endpoint
    class User

      def initialize(client)
        @client = client
      end

      def user(username, params = { per_page: 100 })
        Response::User.new(user_request(username, params))
      end

      private

      def user_request(username, params)
        @client.token.get("/v2/users/#{username}", params: params).parsed
      end
    end
  end
end
