require 'fortytwo/responses/users'

module FortyTwo
  module Endpoint
    class Users

      def initialize(client)
        @client = client
      end

      def users(campus = nil, pool_year = nil, pool_month = nil, params = { page: 1, per_page: 100 })
        Response::Users.new(users_request(campus, pool_year, pool_month, params))
      end

      private

      def users_request(campus, pool_year, pool_month, params)
        @client.token.get("/v2#{campus_path(campus)}/users#{pool_year_filter(pool_year)}#{pool_month_filter(pool_month)}", params: params).parsed
      end

      def campus_path(campus)
        "/campus/#{campus}" if campus
      end

      def pool_year_filter(pool_year)
        "?filter[pool_year]=#{pool_year}" if pool_year
      end

      def pool_month_filter(pool_month)
        "&filter[pool_month]=#{pool_month}" if pool_month
      end
    end
  end
end
