require "active_support/all"

module FortyTwo
  module Response
    class Base
      def initialize(json)
        return if json.nil?
        return instance_variable_set(instance_variable_name, json) if json.is_a?(Array)

        json.each do |key, value|
          key = key.chomp('?') if key.end_with?('?')
          instance_variable_set("@#{key}", value)
        end
      end

      private

      def parse(json, klass)
        return json.map { |j| klass.new(j) } if json.is_a?(Array)
        return klass.new(json) if json
        nil
      end

      def instance_variable_name
        "@#{self.class.name.demodulize.underscore}"
      end
    end
  end
end
