require 'fortytwo/responses/base'
require 'fortytwo/responses/models/cursus_user'
require 'fortytwo/responses/models/project_user'
require 'fortytwo/responses/models/expertise_user'
require 'fortytwo/responses/models/campus'
require 'fortytwo/responses/models/achievement'

module FortyTwo
  module Response
    module Model
      class User < Response::Base
        attr_reader :id, :email, :login, :first_name, :last_name, :url, :phone,
                    :displayname, :image_url, :correction_point, :staff,
                    :pool_month, :pool_year, :location, :wallet, :cursus_users,
                    :projects_users, :expertises_users, :campus, :groups,
                    :achievements, :titles, :partnerships, :patroned,
                    :patroning, :expertises_users

        def initialize(json)
          super(json)

          @cursus_users       = parse(@cursus_users, CursusUser)
          @projects_users     = parse(@projects_users, ProjectUser)
          @expertises_users   = parse(@expertises_users, ExpertiseUser)
          @campus             = parse(@campus, Campus)
          @achievements       = parse(@achievements, Achievement)
        end
      end
    end
  end
end
